#
# Name: hp_qla2x00.spec
# Copyright: (c)2004-2007 Hewlett-Packard Company
#
# Description: spec file for hp_qla2x00 RPM

Name: hp_qla2x00
Version: 8.01.07.25.02
Release: 1 
Summary: HP QLA HBA Driver
Source: hp_qla2x00.tar.gz
Vendor: Hewlett-Packard
Group: System/Kernel
License: Proprietary
BuildRoot: %{_builddir}/hp_qla2x00

%undefine __check_files

%description
Loads the HP supported QLogic HBA driver.

%build

# Get the kernel version that the binary RPM produced will install on
# either through the HPQLA2X00KVERSION environmental variable or the
# uname -r command

if [ "$HPQLA2X00KVERSION" != "" ]
then
 KERNELVERSION=$HPQLA2X00KVERSION

 # check to make sure this kernel is installed on this machine

 if test ! -d /lib/modules/${KERNELVERSION}
 then
	echo ""
	echo "/lib/modules/${KERNELVERSION} does not exist!"
	echo ""
	exit 1
 fi
else
 KERNELVERSION=`uname -r`
fi

# untar source files

rm -fr $RPM_BUILD_DIR/hp_qla2x00
gunzip $RPM_SOURCE_DIR/hp_qla2x00.tar.gz
tar xvf $RPM_SOURCE_DIR/hp_qla2x00.tar

# Use either the build_driver.rh or build_driver.suse to
# build the driver depending on which distribution we
# are using

cd hp_qla2x00

if test -f /etc/redhat-release
then
 ./build_driver.rh -m $KERNELVERSION
elif test -f /etc/SuSE-release
then
 ./build_driver.suse -m $KERNELVERSION -s linux-"`echo $KERNELVERSION | awk 'BEGIN {FS="-"} {print $1"-"$2}'`"
fi

%install

OPTDIR=opt/hp/hp_qla2x00
DRIVERVERSION="`cat hp_qla2x00/VERSIONFILE`"
LIBDIR="usr/lib"

# copy opt directory files 

mkdir -p $RPM_BUILD_ROOT/$OPTDIR
cp $RPM_BUILD_ROOT/$DRIVERVERSION/qla2300.ko $RPM_BUILD_ROOT/$OPTDIR/qla2300.ko
cp $RPM_BUILD_ROOT/$DRIVERVERSION/qla2xxx.ko $RPM_BUILD_ROOT/$OPTDIR/qla2xxx.ko
cp $RPM_BUILD_ROOT/$DRIVERVERSION/qla2400.ko $RPM_BUILD_ROOT/$OPTDIR/qla2400.ko
cp $RPM_BUILD_ROOT/$DRIVERVERSION/qla2xxx_conf.ko $RPM_BUILD_ROOT/$OPTDIR/qla2xxx_conf.ko
 
%if "%RHEL5" == "true"
cp $RPM_BUILD_ROOT/$DRIVERVERSION/extras/intermodule.ko $RPM_BUILD_ROOT/$OPTDIR/intermodule.ko
%endif

cp $RPM_BUILD_ROOT/$DRIVERVERSION/extras/qla_opts $RPM_BUILD_ROOT/$OPTDIR/qla_opts
cp $RPM_BUILD_ROOT/set_parm $RPM_BUILD_ROOT/$OPTDIR/set_parm
cp $RPM_BUILD_ROOT/set_parm2 $RPM_BUILD_ROOT/$OPTDIR/set_parm2
cp $RPM_BUILD_ROOT/edit_conf $RPM_BUILD_ROOT/$OPTDIR/edit_conf
cp $RPM_BUILD_ROOT/make_initrd $RPM_BUILD_ROOT/$OPTDIR/make_initrd
cp $RPM_BUILD_ROOT/readme.libqlsdm $RPM_BUILD_ROOT/$OPTDIR/readme.libqlsdm
cp $RPM_BUILD_ROOT/unload.sh $RPM_BUILD_ROOT/$OPTDIR/unload.sh

### copy /etc files ###
# echo kernel version into .hp_pkinstall

mkdir -p $RPM_BUILD_ROOT/etc

if [ "$HPQLA2X00KVERSION" = "" ]
then
 echo "`uname -r`" > $RPM_BUILD_ROOT/etc/.hp_pkinstall
else
 echo "$HPQLA2X00KVERSION" > $RPM_BUILD_ROOT/etc/.hp_pkinstall
fi 

# copy qlsdm library based on architecture

mkdir -p $RPM_BUILD_ROOT/$LIBDIR

if [ "`uname -m`" = "i386" ] || [ "`uname -m`" = "i486" ] || [ "`uname -m`" = "i586" ] || [ "`uname -m`" = "i686" ] || [ "`uname -m`" = "x86_64" ]
then
 cp $RPM_BUILD_ROOT/libqlsdm-ia32.so $RPM_BUILD_ROOT/$LIBDIR/libqlsdm.so
elif [ "`uname -m`" = "ia64" ]
then
 cp $RPM_BUILD_ROOT/libqlsdm-ia64.so $RPM_BUILD_ROOT/$LIBDIR/libqlsdm.so
fi

%ifarch x86_64
mkdir -p $RPM_BUILD_ROOT/${LIBDIR}64
cp $RPM_BUILD_ROOT/libqlsdm-x86_64.so $RPM_BUILD_ROOT/${LIBDIR}64/libqlsdm-x86_64.so
%endif

%files

%attr (644,root,root)	/opt/hp/hp_qla2x00/qla2300.ko
%attr (644,root,root)	/opt/hp/hp_qla2x00/qla2400.ko
%attr (644,root,root)	/opt/hp/hp_qla2x00/qla2xxx.ko
%attr (644,root,root)	/opt/hp/hp_qla2x00/qla2xxx_conf.ko
%if "%RHEL5" == "true"
%attr (644,root,root)	/opt/hp/hp_qla2x00/intermodule.ko
%endif
%attr (744,root,root)	/opt/hp/hp_qla2x00/edit_conf
%attr (744,root,root)	/opt/hp/hp_qla2x00/make_initrd
%attr (744,root,root)	/opt/hp/hp_qla2x00/set_parm
%attr (744,root,root)	/opt/hp/hp_qla2x00/set_parm2
%attr (444,root,root)	/opt/hp/hp_qla2x00/readme.libqlsdm
%attr (744,root,root)	/opt/hp/hp_qla2x00/qla_opts
%attr (744,root,root)	/opt/hp/hp_qla2x00/unload.sh
%attr (444,root,root)	/etc/.hp_pkinstall
%attr (644,root,root)	/usr/lib/libqlsdm.so
%ifarch x86_64
%attr (644,root,root)	/usr/lib64/libqlsdm-x86_64.so
%endif

%clean

rm -fr $RPM_BUILD_DIR/hp_qla2x00
gzip $RPM_SOURCE_DIR/hp_qla2x00.tar

%changelog
* Tue Oct 07 2008 Chad Dupuis

- Added 8.01.07.25.02 driver
- Added libqlsdm.so version 4.00build14

* Thu Oct 25 2007 Chad Dupuis

Build 8.01.07.25-2

- Changed autorestore parameter to 0xa0

* Fri Oct 05 2007 Chad Dupuis

Build 8.01.07.25-1

- Added 8.01.07.25 driver

* Thu Sep 27 2007 Chad Dupuis

Build 8.01.07.24-1

- Added 8.01.07.24 driver
- Fixed RPM setting blank values in /etc/modprobe.conf

* Fri Sep 14 2007 Chad Dupuis

Build 8.01.07.22-2

- Fixed distro version checking in build_driver.rh for RHEL 5.x

* Wed Sep 12 2007 Chad Dupuis

Build 8.01.07.22-1

- Added 8.01.07.22 driver

* Wed Aug 29 2007 Chad Dupuis

Build 8.01.07.20-1

- Added 8.01.07.20 driver
- Added 3.00build15pre8 libqlsdm.so
- Added ConfigRequired=0 driver parameter
- Set ql2xautorestore to 0xa

* Tue May 15 2007 Chad Dupuis

Build 8.01.07.14-1

- Added 8.01.07.14 driver

* Thu May 03 2007 Chad Dupuis

Build 8.01.07.11-1

- Added 8.01.07.11 driver

* Fri Apr 27 2007 Chad Dupuis

Build 8.01.07.10-1

- Added 8.01.07.10 driver

* Wed Apr 18 2007 Chad Dupuis

Build 8.01.07.07-1

- Added 8.01.07.07 driver
- Added libqlsdm.so 3.0 build 14

* Mon Apr 07 2007 Chad Dupuis

Build 8.01.07.06-7

- Removed mention of ql2xautorestore flag from set_parm help message

* Fri Mar 30 2007 Chad Dupuis

Build 8.01.07.06-6

- Added 8.01.07.06 driver

* Mon Mar 19 2007 Chad Dupuis

Build 8.01.07.03-5

- Added 8.01.07.03 driver
- Added libqlsdm.so 3.00 build 12
- Remove RHEL 5 only installation restriction

* Fri Mar 09 2007 Chad Dupuis

Build 8.01.07.02-4

- Fixed module load order issue when creating ramdisk on RHEL 5

* Wed Feb 21 2007 Chad Dupuis

Build 8.01.07.02-3

- Added 8.01.07.02 driver
- Added libqlsdm.so version 3.0 build 10
- Added check before building commences to see if the current system
  is running RHEL 5
  
* Wed Feb 09 2007 Chad Dupuis

Build 8.01.07-2

- Fixed scripting error in build_driver.rh when building on RHEL 5

* Wed Jan 24 2007 Chad Dupuis

Build 8.01.07-1

- Add support for RHEL 5
- Add intermodule.ko

* Thu Jan 18 2007 Chad Dupuis

Build 8.01.06.01-6

- Copy libqlsdm-x86_64.so to /usr/lib64

* Thu Jan 11 2007 Chad Dupuis

Build 8.01.06.01-5

- Add entry for libqlsdm-x86_64.so to /etc/hba.conf on x86_64 systems

* Tue Jan 02 2007 Chad Dupuis

Build 8.01.06.01-4

- Added 8.01.06.01 driver
- Added libqlsdm.so version 2.03 build 17
- Added x86_64 version of libqlsdm.so
- Added new make_initrd to account for HP-initrd.img-## initrd format
- Modified manual mode of set_parm to only allow the queue depth to be
  changed
- Fixed problem saving and restoring original inbox modules

* Fri Sep 22 2006 Chad Dupuis

- Fixed problem where edit_conf was altering the module load ordering in the
  initrd
- Removed ql2xexclude_model from the help output of set_parm

* Mon Aug 07 2006 Chad Dupuis

- Added 8.01.06 adapter driver
- Added libqlsdm.so version 2.03 build 15

* Tue Aug 01 2006 Chad Dupuis

- Added 8.01.05 adapter driver
- Added support for SLES 10
- Added libqlsdm.so version 2.03 build 13
- Added new set_parm with better help output and a switch to set the load
  balancing type
- Removed references to qla6312,ko module
- Modify /etc/modprobe.d/module-renames on SLES 10 so that qla* modules are
  named correctly

* Wed Apr 05 2006 Chad Dupuis

- Added 8.01.03-p5 QLogic adapter driver

* Thu Mar 16 2006 Chad Dupuis

- Added 8.01.03-p4 QLogic adapter driver
- Copy x86 version of libqlsdm.so to x86_64 systems

* Mon Jan 23 2006 Chad Dupuis

- Added 8.01.03 QLogic adapter driver
- Change ql2xautorestore to 0x80

* Thu Dec 07 2005 Chad Dupuis

- Added 8.01.03 QLogic adapter driver
- Added libqlsdm.so 2.01.01 beta 3
- Set ql2xautorestore parameter to 0x0 from 0x80
- Fixed problem where qla2xxx could be loaded before qla2xxx_conf.
  This was causing issues with SANsurfer

* Wed Nov 16 2005 Chad Dupuis

- Set ql2xautorestore parameter in /etc/modprobe.conf

* Tue Nov 15 2005 Chad Dupuis

- Added 8.01.03b11 QLogic adapter driver

* Wed Nov 02 2005 Chad Dupuis

- Added 8.01.03b8 QLogic adapter driver

* Tue Nov 01 2005 Chad Dupuis

- Added 8.01.03b7 QLogic adapter driver
- Added 2.01.01 beta 2 SDM library
- Removed scsi_patch_sles8.bin script
- Make driver build scripts use VERSIONFILE to get the driver
  source code directory
- Added support for qla2400.ko module

* Mon Oct 03 2005 Chad Dupuis

- Fixed bug where copying libqlsdm-x86_64.so was not
  succeeding because the file was not present

* Fri Sep 16 2005 Chad Dupuis

- Added version 8.00.02p11 of the QLogic adapter driver

* Thu Sep 15 2005 Chad Dupuis

- Added version 8.00.02p10 of the QLogic adapter driver
- Fixed device discovery issue with MSA1000 LUNs attached to
  the second HBA

* Mon Aug 15 2005 Chad Dupuis

- Added 8.00.02p8 version of the QLogic adapter driver
- Fixed issue with XP LUNS not showing up after boot
- Fixed bus reset issue with XP
- Added ioctl fixes for Rubah libraries
- Added support for Mendicino software
- Make a "*" in /proc always be displayed in front
  of a controller LUN fro an EVA or MSA
- Added strings in the failover table for HSV101,
  HSV111, and HSV200
- Added 2.01.01 beta 1 libqlsdm.so library
- Added x86_64 version of the libqlsdm.so library 

* Fri Jul 28 2005 Chad Dupuis

- Added "remove qla2xxx" line to /etc/modprobe*
- If /etc/qla2xxx.conf exists, run qla_opts
  to update the qla2xxx_conf module
- Applied consolodated patch p7
- Added -j optiont to make commands to build driver
  to speed up compilation
- Added the unload.sh script

* Wed Jul 20 2005 Chad Dupuis

- Make the binary RPM produced from the source RPM only
  install on a specific kernel

* Wed May 11 2005 Chad Dupuis

- Added back original 8.00.02 source code

* Mon May 09 2005 Chad Dupuis

- Added Polyserve patch to sources

* Wed May 04 2005 Chad Dupuis

- Changed version of patched driver to 8.00.02a
- Fixed parameter loading problem
- Fixed ordering of qlogic modules in /etc/sysconfig/kernel
- Added EVA XL patch to 8.00.02 base sources
- Added ql2xlbType parameter in edit_conf and
  set_parm

* Mon Mar 20 2005 Chad Dupuis

- Added 8.00.02 driver sources
- Added new make_initrd that recognizes HP-*
  initrd names
- Added new make_initrd that recognizes 
  HP-initrd-* initrd names

* Fri Jan 28 2005 Chad Dupuis

- Added new version of libqlsdm, 2.01 beta 16
- Added 8.00.02b9 driver sources

* Mon Jan 10 2005 Chad Dupuis

- Added changes so that RPM will build correctly on RHEL 4
- Copy qla2xxx_conf.ko file to system
- Save original kernel module files as .orig and only copy
  them on the initial install
- Updated README

* Tue Oct 19 2004 Chad Dupuis

- Changed set_parm to recognize new default values

  Port Down Retry Count = 30
  Login Retry Count = 30

* Thu Oct 06 2004 Chad Dupuis

- Added 8.00.00 driver sources

* Fri Sep 24 2004 Chad Dupuis

- Added 8.00.00b17-hp sources which fix the following
  bugs
     bus reset issue
     EVA failover issue

* Thu Sep 23 2004 Chad Dupuis

- Added scsi_patch.bin to apply correct HSV110
  entry in scsi_devinfo.c

* Tue Sep 21 2004 Chad Dupuis

- Added 8.00.00b17 driver sources with EVA failover
  patch

* Thu Sep 09 2004 Chad Dupuis

- Use /usr/src/linux/README.SUSE to identify OS
  in edit_conf instead of /etc/issue

* Tue Aug 30 2004 Chad Dupuis

- Added 8.00.00b20 driver sources

* Mon Aug 30 2004 Chad Dupuis

- Added 8.00.00b19 driver sources
- Changed default PDRC for failover configs to 3
- Added ia64 libqlsdm library

* Wed Aug 25 2004 Chad Dupuis

- Added 8.00.00b18 driver sources

* Tue Aug 17 2004 Chad Dupuis

- Added new make_initrd

* Mon Aug 16 2004 Chad Dupuis

- Detect whether a loaded driver is using failover
  or nonfailover mode

* Fri Aug 6 2004 Chad Dupuis

- Added libqlsdm library for x86, x86_64 architectures
- Added code to modify /etc/hba.conf
- Added 8.00.00b17 driver sources

* Wed Jul 21 2004 Chad Dupuis

- Added support for the qla6312 (QLA200) module

* Mon Jul 19 2004 Chad Dupuis

- Added 8.00.00b16 driver sources

* Tue Jun 29 2004 Chad Dupuis

- Added 8.00.00b14 sources

* Thu Jun 24 2004 Chad Dupuis

- Fixed make_initrd to only build an initrd for
  the current running kernel on SUSE distributions

* Tue Jun 15 2004 Chad Dupuis

- Initial development

%pre

# make sure we are installing on a 2.4 kernel

KERNVER=`uname -r | cut -c 1-3`

if [ "$KERNVER" != "2.6" ]
then
 echo ""
 echo "This machine is not running a 2.6 kernel!"
 echo ""
 exit 1
fi

%post

# See what kernel version this RPM was build for.  If it does not exist, 
# exit and tell user to uninstall RPM

if [ "`cat /etc/.hp_pkinstall`" != "" ]
then
 KERNELVERSION=`cat /etc/.hp_pkinstall`
 
 # test if kernel directory exists in /lib/modules

 if test ! -d /lib/modules/$KERNELVERSION
 then
	echo "/lib/modules/$KERNELVERSION does not exist."
	echo "You should uninstall this rpm using the \"rpm -e --noscripts hp_qla2x00\""
	echo "command"
	exit 1
 fi
 echo "Using kernel version $KERNELVERSION from /etc/.hp_pkinstall"
else
 KERNELVERSION=`uname -r`
 echo "Using kernel version $KERNELVERSION from uname -r"
fi

SRCDIR=/opt/hp/hp_qla2x00
MODULELIST="qla2xxx.ko qla2300.ko qla2400.ko qla2xxx_conf.ko"
MODDIR=/lib/modules/$KERNELVERSION/kernel/drivers/scsi/qla2xxx
INTERMODULEDIR=/lib/modules/${KERNELVERSION}/kernel/kernel
RHVERFILE=/etc/redhat-release

# create hp_qla2x00.conf if needed

ls /etc/hp_qla2x00.conf 1>/dev/null 2>/dev/null

if [ $? -ne 0 ]
then
 # determine if a driver already loaded in memory is in failover mode
 # or single path mode.  If no driver is loade default to single path

 if test -d /proc/scsi/qla2xxx
 then
        FOMODE=`more /proc/scsi/qla2xxx/* | grep "Driver version" | grep fo`

        # use set_parm2 to write out the correct settings

        if [ "$FOMODE" = "" ]
        then
                echo "Loaded driver is in nonfailover mode"
                $SRCDIR/set_parm2 -s
        else
                echo "Loaded driver is in failover mode"
                $SRCDIR/set_parm2 -x
        fi
 else
        # no driver loaded, so default to failover mode

        echo "No driver loaded, using failover mode"
        $SRCDIR/set_parm2 -x
 fi
else
 echo "/etc/hp_qla2x00.conf already exists.  Using parameters in the current file."

 # Figure out what failover mode we are in
 CONFFILE_FOMODE=`cat /etc/hp_qla2x00.conf 2>/dev/null | grep failover | awk '{print $3}'`

 # Set that we need a hp_qla2x00.conf update to false
 RPM_CONF_NEEDS_UPDATE=0

 # check to see if ql2xlbType needs to be put in

 if [ "`cat /etc/hp_qla2x00.conf 2>/dev/null | grep load_balancing | awk '{print $3}'`" = "" ]
 then
 	RPM_CONF_NEEDS_UPDATE=1
 fi

 # check to see if ql2xautorestore needs to be put in

 if [ "`cat /etc/hp_qla2x00.conf 2>/dev/null | grep auto_restore | awk '{print $3}'`" = "" ]
 then
 	RPM_CONF_NEEDS_UPDATE=1
 fi

 # check to see if auto_compile needs to be put in

 if [ "`grep auto_compile /etc/hp_qla2x00.conf | awk '{print $3}'`" = "" ]
 then
 	RPM_CONF_NEEDS_UPDATE=1
 fi

 # check to see if config_required needs to be put in

 if [ "`grep config_required /etc/hp_qla2x00.conf | awk '{print $3}'`" = "" ]
 then
	RPM_CONF_NEEDS_UPDATE=1
 fi

 # If there is a parameter that needs update, run set_parm2

 if [ "$RPM_CONF_NEEDS_UPDATE" = "1" ]
 then
	echo "Rerunning set_parm2 to add new configuration parameters"
	
	if [ "$CONFFILE_FOMODE" = "0" ]
	then
		$SRCDIR/set_parm2 -s
	else
		$SRCDIR/set_parm2 -x
	fi				
 fi
fi

# Modify /etc/hba.conf

if [ -f "/etc/hba.conf" ]
then
 # file exists, see if we need to make the edit

 if [ `grep -c libqlsdm.so /etc/hba.conf` -eq 0 ]
 then
        echo "Adding line for libqlsdm.so to /etc/hba.conf"
        echo "qla2xxx   /usr/lib/libqlsdm.so" >> /etc/hba.conf
 fi

 if [ "`uname -m`" = "x86_64" ]
 then
        if [ `grep -c libqlsdm-x86_64.so /etc/hba.conf` -eq 0 ]
        then
                echo "Adding line for libqlsdm-x86_64.so to /etc/hba.conf"
                echo "qla2xxx   /usr/lib64/libqlsdm-x86_64.so" >> /etc/hba.conf
        fi
 fi
else
 # file does not exist, create it

 echo "Modifying /etc/hba.conf"
 echo "qla2xxx  /usr/lib/libqlsdm.so" > /etc/hba.conf

 if [ "`uname -m`" = "x86_64" ]
 then
        echo "qla2xxx   /usr/lib64/libqlsdm-x86_64.so" >> /etc/hba.conf
 fi

 chmod 644 /etc/hba.conf
 chown root:root /etc/hba.conf
fi

cd $SRCDIR

# Copy intermodule.ko

if test -f $RHVERFILE
then
	VERSTR="`cat $RHVERFILE | grep "Red Hat Enterprise Linux"`"

        if [ "`echo $VERSTR | grep "release 4.92"`" != "" ] || [ "`echo $VERSTR | grep "release 5 "`" != "" ]
        then
		if test ! -d $INTERMODULEDIR
		then
        		echo "Creating $INTERMODULEDIR"
        		mkdir -p $INTERMODULEDIR
		fi

		echo "Copying intermodule.ko to $INTERMODULEDIR"
		cp intermodule.ko $INTERMODULEDIR
	fi
fi

# copy new modules

for i in $MODULELIST
do
 # save old modules

 if test ! -f $MODDIR/$i.orig && test -f $MODDIR/$i
 then
 	echo "Saving old $i"
 	mv -f $MODDIR/$i $MODDIR/$i.orig
 fi

 # copy new modules
 echo "Copying $i to $MODDIR"
 cp $i $MODDIR/$i
done

# run depmod

echo "Running depmod -a"
depmod -a

# if /etc/qla2xxx.conf exists, run qla_opts to add SANsurfer
# configuration to the new qla2xxx_conf module

if test -f /etc/qla2xxx.conf
then
 echo "Running qla_opts to update qla2xxx_conf"
 ./qla_opts -w qla2xxx_conf
fi

# edit configuration files

echo ""
./edit_conf

# create new initrd

echo ""
./make_initrd $KERNELVERSION

echo ""
echo "Utility files are located in $SRCDIR"

%preun

if test -f /etc/.hp_pkinstall
then
 cp /etc/.hp_pkinstall /tmp/.hp_pkinstall
fi

%postun

if test ! -f /etc/.hp_pkinstall
then
 ### we are removing the package, so uninstall everything ###

 if [ "`cat /tmp/.hp_pkinstall`" != "" ]
 then
 	KERNELVERSION=`cat /tmp/.hp_pkinstall`
 	echo "Using kernel version $KERNELVERSION from /tmp/.hp_pkinstall"
 else
 	KERNELVERSION=`uname -r`
 	echo "Using kernel version $KERNELVERSION from uname -r"
 fi

 MODULEDIR=/lib/modules/${KERNELVERSION}/kernel/drivers/scsi/qla2xxx
 INTERMODULEDIR=/lib/modules/${KERNELVERSION}/kernel/kernel
 MODLIST="qla2300.ko qla2400.ko qla2xxx.ko qla2xxx_conf.ko"
 if test -f /etc/modprobe.conf.local
 then
        MODCONF=/etc/modprobe.conf.local
 else
        MODCONF=/etc/modprobe.conf
 fi

 SRCDIR="/opt/hp/hp_qla2x00"
 RHVERFILE=/etc/redhat-release

 # remove /etc/hp_qla2x00.conf

 echo "Removing /etc/hp_qla2x00.conf"
 rm -f /etc/hp_qla2x00.conf

 # remove reference from /etc/hba.conf to qla2x00

 echo "Removing reference to libqlsdm from /etc/hba.conf"
 cat /etc/hba.conf | grep -v libqlsdm > /tmp/hba.conf
 mv /etc/hba.conf /etc/hba.conf.old
 mv /tmp/hba.conf /etc/hba.conf
 chmod 644 /etc/hba.conf
 chown root:root /etc/hba.conf

 # remove stuff from /etc/modprobe*

 echo "Removing parameters from $MODCONF"
 cat $MODCONF | grep -v "options qla2xxx" | grep -v "remove qla2xxx" | grep -v "qla2xxx_conf" > $MODCONF.new
 mv -f $MODCONF $MODCONF.old
 mv -f $MODCONF.new $MODCONF
 chmod 644 $MODCONF
 chown root:root $MODCONF

 #
 # Uncomment the QLogic entries in /etc/modprobe.d/module-renames

 FILE=/etc/modprobe.d/module-renames

 # Check to make sure file exists

 if test -f $FILE
 then
        echo "Modifying $FILE"
        FILENEW=$FILE.new

        # Initialze new file
        echo -n "" > $FILENEW

        # Loop through file and uncomment out QLogic lines

        while read line
        do
                if [ "`echo $line | grep qla`" != "" ] && [ "`echo $line | grep qla | grep \#`" != "" ]
                then
                        echo "$line" | sed 's/#//g' >> $FILENEW
                else
                        echo $line >> $FILENEW
                fi
        done < $FILE

        # Move the new file into place

        mv -f $FILENEW $FILE
        chmod 644 $FILE
 fi

 # Remove intermodule.ko

 if test -f $RHVERFILE
 then
        VERSTR="`cat $RHVERFILE | grep "Red Hat Enterprise Linux"`"

        if [ "`echo $VERSTR | grep "release 4.92"`" != "" ] || [ "`echo $VERSTR | grep "release 5 "`" != "" ]
        then
       		 echo "Removing $INTERMODULEDIR/intermodule.ko"
		 rm -f $INTERMODULEDIR/intermodule.ko
	fi
 fi

 # remove modules and restore old ones
 
 for i in $MODLIST
 do
 	if test -f $MODULEDIR/$i
 	then
 		echo "Removing $MODULEDIR/$i"
 		rm -f $MODULEDIR/$i
 	fi

 	if test -f $MODULEDIR/$i.orig
 	then
		echo "Restoring old $i"
		mv -f $MODULEDIR/$i.orig $MODULEDIR/$i
 	fi
 done

 # run depmod -a

 echo "Running depmod -a"
 depmod -a

 # remove /opt/hp/hp_qla2x00

 echo "Removing $SRCDIR"

 cd $SRCDIR

 if [ $? -eq 0 ]
 then
 	rm -f *
 	cd ../
 	rmdir $SRCDIR
 fi

 # cleanup

 rm -f /tmp/.hp_pkinstall

 echo ""
 echo "Your initrd has not been updated.  You will have to do that manually."
else
 # if this is an upgrade, don't remove anything

 echo -n "" # no-op
fi

exit 0

